package mezz.jei.api.constants;

import java.util.List;
import mezz.jei.api.ingredients.IIngredientType;
import mezz.jei.api.recipe.category.extensions.vanilla.crafting.ICraftingCategoryExtension;
import mezz.jei.api.recipe.vanilla.IVanillaRecipeFactory;
import mezz.jei.api.registration.IRecipeRegistration;
import net.minecraft.class_1799;
import net.minecraft.class_2960;
import net.minecraft.class_3859;
import net.minecraft.class_3861;
import net.minecraft.class_3862;
import net.minecraft.class_3920;
import net.minecraft.class_3962;
import net.minecraft.class_3975;
import net.minecraft.class_5357;

/**
 * List of built-in recipe category UIDs, so that plugins with their own recipe handlers can use them.
 *
 * @deprecated This has been replaced by {@link RecipeTypes}.
 */
@Deprecated(forRemoval = true, since = "9.5.0")
public final class VanillaRecipeCategoryUid {
	/**
	 * The crafting recipe category.
	 *
	 * Automatically includes all vanilla and Forge recipes.
	 *
	 * To add a shaped recipe extension to this category, it must implement
	 * {@link ICraftingCategoryExtension#getWidth()} and {@link ICraftingCategoryExtension#getHeight()}.
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 CRAFTING = RecipeTypes.CRAFTING.getUid();

	/**
	 * The stonecutting recipe category
	 *
	 * Automatically includes every {@link class_3975}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 STONECUTTING = RecipeTypes.STONECUTTING.getUid();

	/**
	 * The furnace recipe category.
	 *
	 * Automatically includes every {@link class_3861}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 FURNACE = RecipeTypes.SMELTING.getUid();

	/**
	 * The smoking recipe category.
	 *
	 * Automatically includes every {@link class_3862}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 SMOKING = RecipeTypes.SMOKING.getUid();

	/**
	 * The blasting recipe category.
	 *
	 * Automatically includes every {@link class_3859}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 BLASTING = RecipeTypes.BLASTING.getUid();

	/**
	 * The campfire furnace recipe category.
	 *
	 * Automatically includes every {@link class_3920}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 CAMPFIRE = RecipeTypes.CAMPFIRE_COOKING.getUid();

	/**
	 * The fuel recipe category.
	 *
	 * Automatically includes everything that has a burn time.
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 FUEL = RecipeTypes.FUELING.getUid();

	/**
	 * The brewing recipe category.
	 *
	 * Automatically tries to generate all potion variations from the basic ingredients.
	 *
	 * Also automatically adds modded potions from the Forge BrewingRecipeRegistry.
	 * JEI can only understand modded potion recipes that are built into vanilla or Forge.
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 BREWING = RecipeTypes.BREWING.getUid();

	/**
	 * The anvil recipe category.
	 *
	 * This is a built-in category, you can create new recipes with {@link IVanillaRecipeFactory#createAnvilRecipe(class_1799, List, List)}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 ANVIL = RecipeTypes.ANVIL.getUid();

	/**
	 * The smithing recipe category.
	 *
	 * Automatically includes every {@link class_5357}.
	 * @since 7.3.1
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 SMITHING = RecipeTypes.SMITHING.getUid();

	/**
	 * The compostable recipe category.
	 *
	 * Automatically includes every item added to {@link class_3962#field_17566}.
	 * @since 8.1.0
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 COMPOSTABLE = RecipeTypes.COMPOSTING.getUid();

	/**
	 * The JEI info recipe category shows extra information about ingredients.
	 *
	 * This is a built-in category, you can add new recipes with
	 * {@link IRecipeRegistration#addIngredientInfo(Object, IIngredientType, net.minecraft.class_2561...)} or
	 * {@link IRecipeRegistration#addIngredientInfo(List, IIngredientType, net.minecraft.class_2561...)}
	 */
	@Deprecated(forRemoval = true, since = "9.5.0")
	public static final class_2960 INFORMATION = RecipeTypes.INFORMATION.getUid();

	private VanillaRecipeCategoryUid() {

	}
}
